* Program.: POS.PRG
* Author..: Robert Marks
#pragma Library( "DCLIPX.LIB" )
#include "appevent.ch"
#include "dcdialog.ch"

#define PAN_BHEIGHT 1.3
#define PAN_BROWS  4

STATIC oRootWindow, nMaxCol, nFontWidth

Function MAIN()
  oRootWindow:=SetAppWindow()
  nMaxCol:=oRootWindow:maxCol
  nFontWidth:=oRootWindow:fontWidth

  MyPanApp()

 RETURN (Nil)

Function MyPanApp()
  MEMVAR aWindow, aField, MS_TimeOut, lPanApp

  LOCAL GetList:={}, GetOptions, oItem:=NIL
  LOCAL cItemHeader, lReturn:=.F.
  LOCAL cTitle:="Testing Testing and More Testing"
  LOCAL cItem:=SPACE(14), nFontSize:=INT(nFontWidth)
/* -- Item Entry -- */
  cItemHeader:="Compare pressing ALT-A (slow) verses clicking on 'Alt-A' button"
  @ PAN_BROWS+3,1.6 DCSAY cItemHeader SAYLEFT ;
       SAYFONT VAR2CHAR(INT(nFontSize*MIN(1,(nMAXCOL+5)/LEN(cItemHeader))))+ ;
               ".Courier New"
  cItemHeader:="or pressing ALT-PGDN or clicking on 'Alt-PGDN' button"
  @ PAN_BROWS+3.7,1.6 DCSAY cItemHeader SAYLEFT ;
       SAYFONT VAR2CHAR(INT(nFontSize*MIN(1,(nMAXCOL+5)/LEN(cItemHeader))))+ ;
               ".Courier New"
  @ PAN_BROWS+5,1 DCSAY "Item" GET cItem PICTURE "@!" GETOBJECT oItem SAYRIGHT
  @ PAN_BROWS+7,1 DCPUSHBUTTON CAPTION {|| 'Alt-A'} ;
      ACCELKEY xbeK_ALT_A SIZE 10,PAN_BHEIGHT ;
      ACTION {|| MyPanAddItem(),SetAppFocus(oItem) }
  @ PAN_BROWS+7,12 DCPUSHBUTTON CAPTION {|| 'Alt-PGDN'} ;
      ACCELKEY xbeK_ALT_PGDN SIZE 10,PAN_BHEIGHT ;
      ACTION {|| MyPanAddItem(),SetAppFocus(oItem) }
  @ PAN_BROWS+7,34 DCPUSHBUTTON CAPTION 'Exit' SIZE 10,PAN_BHEIGHT ;
      ACCELKEY xbeK_F8 CARGO 'CANCEL' ;
      ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)}

/* -- DCREAD -- */
  DCGETOPTIONS WINDOWROW 4*nFontWidth+1 WINDOWCOL 1 ;
     WINDOWWIDTH nFontSize*nMAXCOL WINDOWHEIGHT (2*nFontSize+4)*(15.5)

  DCREAD GUI TITLE cTitle CLEAREVENTS SETFOCUS @oItem ;
     OPTIONS GetOptions NOENTEREXIT APPWINDOW oRootWindow ;
     OWNER SetAppWindow() SETAPPWINDOW ;
     EVAL {|o| SetAppWindow(o), ;
            o:setModalState(IIF(o:setOwner()<>o:setParent(),XBP_DISP_APPMODAL, ;
                                XBP_DISP_MODELESS)),;
            o:setDisplayFocus:={|x,y,o| SetAppWindow(o)}}
RETURN lReturn

Static Function MyPanAddItem()
  dc_Alert("How long did this take to pop up?",{"Continue"})
  CLEAR TYPEAHEAD
RETURN .F.


